
void popup_center_mouse(GtkWidget *win);
void popup_center(GtkWidget *win, GtkWidget *ref);
void popup_center_position(GtkWidget *win, int x, int y);


void
popup_center(GtkWidget *win, GtkWidget *ref)
{
	int x, y, width, height;
	gdk_window_get_geometry(ref->window, &x, &y, &width, &height, NULL);
	if(GTK_WIDGET_NO_WINDOW(ref)) {
		x += ref->allocation.x + ref->allocation.width/2;
		y += ref->allocation.y + ref->allocation.height/2;
	} else {
		x += width/2;
		y += height/2;
	}

	popup_center_position(win, x, y);
}

void
popup_center_mouse(GtkWidget *win)
{
	int x, y;
	gdk_window_get_pointer(NULL, &x, &y, NULL);

	popup_center_position(win, x, y);
}

void
popup_center_position(GtkWidget *win, int x, int y)
{
	GtkWidget *top;
	int win_width, win_height;
	top = gtk_widget_get_toplevel(win);

	x = x - win->allocation.width/2;
	y = y - win->allocation.height/2;

	if(top != win) {
		x = x - win->allocation.x;
		y = y - win->allocation.y;
	} 

	win_width = top->allocation.width;
	win_height = top->allocation.height;

	if(x < 0) x = 0;
	else if(x > gdk_screen_width() - win_width) {
		x = gdk_screen_width() - win_width;
	}
	if(y < 0) y = 0;
	else if(y > gdk_screen_height() - win_height) {
		y = gdk_screen_height() - win_height;
	}
	gtk_widget_popup(top, x, y);
}


