
/* this file is a part of gau software, (C) Hwang chi-duck 1997               */

#include <gtk/gtk.h>
#include <gdk/automata.h>
#include "fixedlabel.h"

extern char tmpbuf[];
extern void hangul_input_toggle(gpointer foo);
GtkWidget *status_label;
GtkWidget *time_label;
GtkWidget *han_input_label;
GtkWidget *keyboard_label;

extern void (*automata_hangul_input_state_changed)(void);
void han_input_state_show(void) 
{
	if(hangul_input()) fixed_label_set(FIXED_LABEL(han_input_label), " ѱ ");
	else fixed_label_set(FIXED_LABEL(han_input_label), "  ");
}

void
keyboard_button_click(GtkWidget *w)
{
	if(hangul_keyboard_get() == 2) {
		hangul_keyboard_set(3);
		fixed_label_set(FIXED_LABEL(keyboard_label), "3");
	} else {
		hangul_keyboard_set(2);
		fixed_label_set(FIXED_LABEL(keyboard_label), "2");
	}
}

void
status_bar(GtkWidget *box)
{
	GtkWidget *frame;
	GtkWidget *hbox, *button;

	automata_hangul_input_state_changed = han_input_state_show;

	status_label = fixed_label_new("");
	gtk_widget_set_name(status_label, "status-label");
	gtk_box_pack_start(GTK_BOX(box), status_label, FALSE, FALSE, 2);
	gtk_misc_set_alignment(GTK_MISC(status_label), 0.0, 0.5);
	gtk_widget_show(status_label);

	// time
	frame = gtk_frame_new(NULL);
	gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_ETCHED_IN);
	gtk_box_pack_end(GTK_BOX(box), frame, FALSE, FALSE, 5);
	gtk_widget_show(frame);
	time_label = fixed_label_new(" 00:00 ");
	gtk_widget_set_name(time_label, "time-label");
	gtk_container_add(GTK_CONTAINER(frame), time_label);
	gtk_widget_show(time_label);

	// han input state
	frame = gtk_frame_new(NULL);
	gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_ETCHED_IN);
	gtk_box_pack_end(GTK_BOX(box), frame, FALSE, FALSE, 5);
	gtk_widget_show(frame);

	hbox = gtk_hbox_new(FALSE, 2);
	gtk_container_add(GTK_CONTAINER(frame), hbox);
	gtk_widget_show(hbox);

    button = gtk_button_new();
	GTK_WIDGET_UNSET_FLAGS(button, GTK_CAN_FOCUS);
	gtk_widget_show(button);
	gtk_box_pack_start(GTK_BOX(hbox), button, FALSE, FALSE, 2);
	han_input_label = fixed_label_new("  ");
	gtk_container_add(GTK_CONTAINER(button), han_input_label);
	han_input_state_show();
	gtk_signal_connect(GTK_OBJECT(button), "clicked",
		GTK_SIGNAL_FUNC(hangul_input_toggle), NULL);
	gtk_widget_show(han_input_label);

	button = gtk_button_new();
	GTK_WIDGET_UNSET_FLAGS(button, GTK_CAN_FOCUS);

	gtk_box_pack_start(GTK_BOX(hbox), button, FALSE, FALSE, 2);
	if(hangul_keyboard_get() == 2) 
		keyboard_label = fixed_label_new("2");
	else
		keyboard_label = fixed_label_new("3");
	gtk_container_add(GTK_CONTAINER(button), keyboard_label);
	gtk_signal_connect(GTK_OBJECT(button), "clicked",
		GTK_SIGNAL_FUNC(keyboard_button_click), NULL);
	gtk_widget_show(keyboard_label);
	gtk_widget_show(button);

	// in & out status report
#if 0
	in_pixmap[0] = ;
	in_pixmap[1] = ;
	out_pixmap[0] = ;
	out_pixmap[1] = ;
#endif
}

void
append_message(char *buf)
{
	char *orig;
	fixed_label_get(FIXED_LABEL(status_label), &orig);
	sprintf(tmpbuf, "%s %s", orig, buf);
	fixed_label_set(FIXED_LABEL(status_label), tmpbuf);
}

void
show_message(char *buf)
{
	fixed_label_set(FIXED_LABEL(status_label), buf);
}

void
show_time(int second)
{
	char tmp_buf[6];
	sprintf(tmp_buf, " %02d:%02d ", second/60, second%60);
	fixed_label_set(FIXED_LABEL(time_label), tmp_buf);
}

void
show_incoming(gboolean flag)
{
}

void
show_outgoing(gboolean flag)
{
}

